diff --git a/src/widgetCollection/playlistWidget.cpp b/src/widgetCollection/playlistWidget.cpp
index 401aa14..c65940c 100644
--- a/src/widgetCollection/playlistWidget.cpp
+++ b/src/widgetCollection/playlistWidget.cpp
@@ -17,6 +17,7 @@
 
 #include <QContextMenuEvent>
 #include <QDrag>
+#include <QKeyEvent>
 #include <QMap>
 #include <QScrollBar>
 
@@ -45,9 +46,7 @@ NPlaylistWidget::NPlaylistWidget(QWidget *parent) : QListWidget(parent)
     Q_ASSERT(m_playbackEngine);
 
     // triggered bu user input (double click or enter, depending on platform):
-    connect(this, &QListWidget::itemActivated, [this](QListWidgetItem *item) {
-        playItem(reinterpret_cast<NPlaylistWidgetItem *>(item));
-    });
+    connect(this, SIGNAL(itemActivated(QListWidgetItem*)), this, SLOT(on_itemActivated(QListWidgetItem*)));
     connect(m_playbackEngine, SIGNAL(mediaFinished(const QString &, int)), this,
             SLOT(on_playbackEngine_mediaFinished(const QString &, int)));
     connect(m_playbackEngine, SIGNAL(mediaFailed(const QString &, int)), this,
@@ -74,10 +73,7 @@ NPlaylistWidget::NPlaylistWidget(QWidget *parent) : QListWidget(parent)
 
     m_processVisibleItemsTimer = new QTimer(this);
     m_processVisibleItemsTimer->setSingleShot(true);
-    connect(m_processVisibleItemsTimer, &QTimer::timeout, [this]() {
-        processVisibleItems();
-        calculateDuration();
-    });
+    connect(m_processVisibleItemsTimer, SIGNAL(timeout()), this, SLOT(on_processVisibleItemsTimer_timeout()));
     connect(verticalScrollBar(), SIGNAL(valueChanged(int)), this,
             SLOT(startProcessVisibleItemsTimer()));
 }
@@ -125,7 +121,7 @@ void NPlaylistWidget::processVisibleItems()
 QStringList NPlaylistWidget::selectedFiles() const
 {
     QStringList files;
-    for (QListWidgetItem *item : selectedItems()) {
+    foreach (QListWidgetItem *item, selectedItems()) {
         files << item->data(N::PathRole).toString();
     }
     return files;
@@ -137,6 +133,33 @@ void NPlaylistWidget::wheelEvent(QWheelEvent *event)
     event->accept();
 }
 
+void NPlaylistWidget::keyPressEvent(QKeyEvent *event)
+{
+    // Qt4: Handle Delete and Backspace keys for removing selected items
+    // On macOS, Cmd+Backspace is the standard delete shortcut
+    bool isDeleteKey = (event->key() == Qt::Key_Delete ||
+                        event->key() == Qt::Key_Backspace);
+
+#ifdef Q_OS_MAC
+    // macOS: Cmd+Backspace
+    bool isDeleteShortcut = (event->key() == Qt::Key_Backspace &&
+                             event->modifiers() & Qt::MetaModifier);
+#else
+    // Linux/Windows: Ctrl+Backspace
+    bool isDeleteShortcut = (event->key() == Qt::Key_Backspace &&
+                             event->modifiers() & Qt::ControlModifier);
+#endif
+
+    if ((isDeleteKey || isDeleteShortcut) && selectedItems().count() > 0) {
+        removeSelected();
+        event->accept();
+        return;
+    }
+
+    // For all other keys, use default QListWidget behavior
+    QListWidget::keyPressEvent(event);
+}
+
 void NPlaylistWidget::contextMenuEvent(QContextMenuEvent *event)
 {
     if (selectedItems().size() != 0 && itemAt(event->pos())) {
@@ -156,7 +179,7 @@ void NPlaylistWidget::removeFiles(const QStringList &files)
     }
 
     std::reverse(rowsToRemove.begin(), rowsToRemove.end());
-    for (int row : rowsToRemove) {
+    foreach (int row, rowsToRemove) {
         delete takeItem(row);
     }
 
@@ -742,6 +765,12 @@ void NPlaylistWidget::dragEnterEvent(QDragEnterEvent *event)
     }
 
     QListWidget::dragEnterEvent(event);
+
+    // Qt4: Explicitly accept external file drops (from Finder/file manager)
+    // QListWidget::dragEnterEvent only accepts internal drags (item reordering)
+    if (event->mimeData() && event->mimeData()->hasUrls()) {
+        event->acceptProposedAction();
+    }
 }
 
 void NPlaylistWidget::dragMoveEvent(QDragMoveEvent *event)
@@ -751,6 +780,11 @@ void NPlaylistWidget::dragMoveEvent(QDragMoveEvent *event)
     }
 
     QListWidget::dragMoveEvent(event);
+
+    // Qt4: Explicitly accept external file drops during drag move
+    if (event->mimeData() && event->mimeData()->hasUrls()) {
+        event->acceptProposedAction();
+    }
 }
 
 void NPlaylistWidget::dragLeaveEvent(QDragLeaveEvent *event)
@@ -819,3 +853,14 @@ void NPlaylistWidget::setFileDropRadius(int radius)
     m_fileDropRadius = radius;
 }
 // << STYLESHEET PROPERTIES
+
+void NPlaylistWidget::on_itemActivated(QListWidgetItem *item)
+{
+    playItem(reinterpret_cast<NPlaylistWidgetItem *>(item));
+}
+
+void NPlaylistWidget::on_processVisibleItemsTimer_timeout()
+{
+    processVisibleItems();
+    calculateDuration();
+}
diff --git a/src/widgetCollection/playlistWidget.h b/src/widgetCollection/playlistWidget.h
index f78340a..0979aff 100644
--- a/src/widgetCollection/playlistWidget.h
+++ b/src/widgetCollection/playlistWidget.h
@@ -22,7 +22,7 @@
 
 #include "global.h"
 
-class NPlaylistDataItem;
+struct NPlaylistDataItem;
 class NPlaylistWidgetItem;
 class NTrackInfoReader;
 class NPlaybackEngineInterface;
@@ -61,6 +61,7 @@ private:
 
 protected:
     void wheelEvent(QWheelEvent *event);
+    void keyPressEvent(QKeyEvent *event);
 
 protected slots:
     void rowsInserted(const QModelIndex &parent, int start, int end);
@@ -70,6 +71,8 @@ private slots:
 
     void on_playbackEngine_mediaChanged(const QString &file, int id);
     void on_playbackEngine_prepareNextMediaRequested();
+    void on_itemActivated(QListWidgetItem *item);
+    void on_processVisibleItemsTimer_timeout();
     void on_playbackEngine_mediaFinished(const QString &file, int id);
     void on_playbackEngine_mediaFailed(const QString &file, int id);
 
@@ -125,13 +128,13 @@ public:
         DragStartInside,
         DragStartOutside
     };
-    Q_ENUM(DragStart)
+    Q_ENUMS(DragStart)
     enum DropEnd
     {
         DropEndInside,
         DropEndOutside
     };
-    Q_ENUM(DropEnd)
+    Q_ENUMS(DropEnd)
 private:
     DragStart m_dragStart;
     DropEnd m_dropEnd;
diff --git a/src/widgetCollection/playlistWidgetItem.cpp b/src/widgetCollection/playlistWidgetItem.cpp
index 6768019..7821bbc 100644
--- a/src/widgetCollection/playlistWidgetItem.cpp
+++ b/src/widgetCollection/playlistWidgetItem.cpp
@@ -124,7 +124,7 @@ void NPlaylistWidgetItemDelegate::paint(QPainter *painter, const QStyleOptionVie
                                         const QModelIndex &index) const
 {
     QStyleOptionViewItem opt = option;
-    const NPlaylistWidget *playlistWidget = qobject_cast<const NPlaylistWidget *>(opt.widget);
+    const NPlaylistWidget *playlistWidget = qobject_cast<const NPlaylistWidget *>(parent());
 
     if (index.data(N::FailedRole).toBool()) { // FailedRole has higher priority than PlayingRole
         QColor color = playlistWidget->failedTextColor();
diff --git a/src/widgetCollection/slider.h b/src/widgetCollection/slider.h
index fa15f9b..dcd2dc9 100644
--- a/src/widgetCollection/slider.h
+++ b/src/widgetCollection/slider.h
@@ -27,9 +27,9 @@ public:
     qreal valueAtPos(int pos);
 
 protected:
-    virtual void mousePressEvent(QMouseEvent *event) override;
-    virtual void mouseMoveEvent(QMouseEvent *event) override;
-    virtual void wheelEvent(QWheelEvent *event) override;
+    virtual void mousePressEvent(QMouseEvent *event);
+    virtual void mouseMoveEvent(QMouseEvent *event);
+    virtual void wheelEvent(QWheelEvent *event);
 
 private slots:
     void setValue(int){};
diff --git a/src/widgetCollection/volumeSlider.h b/src/widgetCollection/volumeSlider.h
index b51062a..84ae9e2 100644
--- a/src/widgetCollection/volumeSlider.h
+++ b/src/widgetCollection/volumeSlider.h
@@ -26,9 +26,9 @@ public:
     NVolumeSlider(QWidget *parent);
 
 private:
-    void mousePressEvent(QMouseEvent *event) override;
-    void mouseMoveEvent(QMouseEvent *event) override;
-    void wheelEvent(QWheelEvent *e) override;
+    void mousePressEvent(QMouseEvent *event);
+    void mouseMoveEvent(QMouseEvent *event);
+    void wheelEvent(QWheelEvent *e);
     QString toolTipText(int value) const;
 
 private slots:
diff --git a/src/widgetCollection/waveformSlider.cpp b/src/widgetCollection/waveformSlider.cpp
index d784ec6..02f6cf2 100644
--- a/src/widgetCollection/waveformSlider.cpp
+++ b/src/widgetCollection/waveformSlider.cpp
@@ -119,9 +119,8 @@ void NWaveformSlider::checkForUpdate()
 
     if (m_needsUpdate) {
         QPainter painter;
-        qreal dpr = devicePixelRatioF();
+        qreal dpr = 1.0;  // Qt4 doesn't have 1.0
         QImage image(width() * dpr, height() * dpr, QImage::Format_ARGB32_Premultiplied);
-        image.setDevicePixelRatio(dpr);
         QImage waveImage;
         waveImage = m_backgroundImage = m_progressPlayingImage = m_progressPausedImage =
             m_remainingPlayingImage = m_remainingPausedImage = image;
@@ -200,7 +199,7 @@ void NWaveformSlider::paintEvent(QPaintEvent *)
 
     if (m_hasMedia) {
         qreal x = (qreal)value() / maximum() * width();
-        qreal dpr = devicePixelRatioF();
+        qreal dpr = 1.0;
         QTransform transform;
         transform.scale(dpr, dpr);
 
diff --git a/src/widgetCollection/waveformSlider.h b/src/widgetCollection/waveformSlider.h
index 7473fcb..01ba016 100644
--- a/src/widgetCollection/waveformSlider.h
+++ b/src/widgetCollection/waveformSlider.h
@@ -20,7 +20,7 @@
 #include <QPainter>
 #include <QVector>
 
-class NPlaylistDataItem;
+struct NPlaylistDataItem;
 class NWaveformBuilderInterface;
 
 class NWaveformSlider : public QAbstractSlider
diff --git a/src/widgetCollection/widgetCollection.cpp b/src/widgetCollection/widgetCollection.cpp
index 4bfb613..6643810 100644
--- a/src/widgetCollection/widgetCollection.cpp
+++ b/src/widgetCollection/widgetCollection.cpp
@@ -27,10 +27,10 @@
 
 // clang-format off
 #define N_WIDGET_PLUGIN(CLASS_NAME) \
-class CLASS_NAME##Plugin : public QObject, public NWidgetPlugin \
+class CLASS_NAME##Plugin : public NWidgetPlugin \
 { \
 public: \
-    CLASS_NAME##Plugin(QObject *parent = 0) : QObject(parent), NWidgetPlugin(#CLASS_NAME) {} \
+    CLASS_NAME##Plugin(QObject *parent = 0) : NWidgetPlugin(#CLASS_NAME) { Q_UNUSED(parent); } \
     virtual QWidget* createWidget(QWidget *parent) { return new CLASS_NAME(parent); } \
     virtual bool isContainer() const { return false; } \
 }; \
@@ -79,7 +79,7 @@ void NWidgetPlugin::initialize(QDesignerFormEditorInterface *core)
     m_initialized = true;
 }
 
-NWidgetCollection::NWidgetCollection(QObject *parent) : QObject(parent)
+NWidgetCollection::NWidgetCollection(QObject *parent) : QObject(parent), QDesignerCustomWidgetCollectionInterface()
 {
     m_plugins.push_back(new NWaveformSliderPlugin(this));
     m_plugins.push_back(new QSizeGripPlugin(this));
@@ -89,3 +89,5 @@ NWidgetCollection::NWidgetCollection(QObject *parent) : QObject(parent)
     m_plugins.push_back(new NLabelPlugin(this));
     m_plugins.push_back(new NCoverWidgetPlugin(this));
 }
+
+Q_EXPORT_PLUGIN2(widgetcollection, NWidgetCollection)
diff --git a/src/widgetCollection/widgetCollection.h b/src/widgetCollection/widgetCollection.h
index 7dd84e4..f7c562b 100644
--- a/src/widgetCollection/widgetCollection.h
+++ b/src/widgetCollection/widgetCollection.h
@@ -25,9 +25,11 @@
 #include <QtUiPlugin/QDesignerCustomWidgetInterface>
 #endif
 
-class NWidgetPlugin : public QDesignerCustomWidgetInterface
+class NWidgetPlugin : public QObject, public QDesignerCustomWidgetInterface
 {
-    Q_INTERFACES(QDesignerCustomWidgetInterface)
+    Q_OBJECT
+    // Q_INTERFACES not needed for Qt4 static plugins using Q_EXPORT_PLUGIN2
+    // Only the collection class (NWidgetCollection) needs Q_INTERFACES
 
 private:
     bool m_initialized;
@@ -42,6 +44,8 @@ public:
     QString name() const { return m_className; }
     void initialize(QDesignerFormEditorInterface *core);
     bool isInitialized() const { return m_initialized; }
+    virtual QWidget *createWidget(QWidget *parent) = 0;
+    virtual bool isContainer() const = 0;
     virtual QIcon icon() const { return QIcon(); }
     virtual QString whatsThis() const { return QString(); }
     virtual QString toolTip() const { return QString(); }
@@ -53,8 +57,7 @@ public:
 class NWidgetCollection : public QObject, public QDesignerCustomWidgetCollectionInterface
 {
     Q_OBJECT
-    Q_INTERFACES(QDesignerCustomWidgetCollectionInterface)
-    Q_PLUGIN_METADATA(IID "com.nulloy.NWidgetCollection")
+    // Q_INTERFACES not needed for Qt4 static plugins using Q_EXPORT_PLUGIN2
 
 public:
     NWidgetCollection(QObject *parent = 0);
diff --git a/src/widgetCollection/widgetCollection.pro b/src/widgetCollection/widgetCollection.pro
index 2e45ae6..4229fb9 100644
--- a/src/widgetCollection/widgetCollection.pro
+++ b/src/widgetCollection/widgetCollection.pro
@@ -2,7 +2,9 @@ TEMPLATE = lib
 TARGET = widget_collection
 DESTDIR = $$PWD
 
-QT += designer gui
+# Qt4 doesn't have separate designer module, Qt5+ does
+greaterThan(QT_MAJOR_VERSION, 4): QT += designer
+QT += gui
 CONFIG += plugin static
 
 include(widgetCollection.pri)
diff --git a/tests/testPlaylistWidget.cpp b/tests/testPlaylistWidget.cpp
index f767eba..6562762 100644
--- a/tests/testPlaylistWidget.cpp
+++ b/tests/testPlaylistWidget.cpp
@@ -61,8 +61,8 @@ private slots:
     void cleanup()
     {
         delete m_playlistWidget;
-        m_playlistWidget = nullptr;
-        m_playbackEngine = nullptr;
+        m_playlistWidget = 0;
+        m_playbackEngine = 0;
     }
 
     void testPlaylistRemoval()
diff --git a/src/customUiLoader.h b/src/customUiLoader.h
new file mode 100644
index 0000000..7c22024
--- /dev/null
+++ b/src/customUiLoader.h
@@ -0,0 +1,83 @@
+/********************************************************************
+**  Nulloy Music Player, http://nulloy.com
+**  Copyright (C) 2010-2024 Sergey Vlasov <sergey@vlasov.me>
+**
+**  This program can be distributed under the terms of the GNU
+**  General Public License version 3.0 as published by the Free
+**  Software Foundation and appearing in the file LICENSE.GPL3
+**  included in the packaging of this file.  Please review the
+**  following information to ensure the GNU General Public License
+**  version 3.0 requirements will be met:
+**
+**  http://www.gnu.org/licenses/gpl-3.0.html
+**
+*********************************************************************/
+
+#ifndef N_CUSTOM_UI_LOADER_H
+#define N_CUSTOM_UI_LOADER_H
+
+#include <QtUiTools/QUiLoader>
+
+#ifndef _N_NO_SKINS_
+
+#include "widgetCollection/coverWidget.h"
+#include "widgetCollection/label.h"
+#include "widgetCollection/playlistWidget.h"
+#include "widgetCollection/volumeSlider.h"
+#include "widgetCollection/waveformSlider.h"
+
+// Custom QUiLoader for Qt4 static plugin widgets
+// Qt4's QUiLoader doesn't automatically discover static plugins,
+// so we need to manually instantiate our custom widgets
+class NCustomUiLoader : public QUiLoader
+{
+public:
+    NCustomUiLoader(QObject *parent = 0) : QUiLoader(parent) {}
+
+    // Override availableWidgets to include our custom widgets
+    // This tells QUiLoader that these widgets exist
+    QStringList availableWidgets() const
+    {
+        QStringList widgets = QUiLoader::availableWidgets();
+        widgets << "NLabel";
+        widgets << "NWaveformSlider";
+        widgets << "NVolumeSlider";
+        widgets << "NPlaylistWidget";
+        widgets << "NCoverWidget";
+        return widgets;
+    }
+
+protected:
+    QWidget *createWidget(const QString &className, QWidget *parent = 0,
+                          const QString &name = QString())
+    {
+        if (className == "NLabel") {
+            NLabel *widget = new NLabel(parent);
+            widget->setObjectName(name);
+            return widget;
+        } else if (className == "NWaveformSlider") {
+            NWaveformSlider *widget = new NWaveformSlider(parent);
+            widget->setObjectName(name);
+            return widget;
+        } else if (className == "NVolumeSlider") {
+            NVolumeSlider *widget = new NVolumeSlider(parent);
+            widget->setObjectName(name);
+            return widget;
+        } else if (className == "NPlaylistWidget") {
+            NPlaylistWidget *widget = new NPlaylistWidget(parent);
+            widget->setObjectName(name);
+            return widget;
+        } else if (className == "NCoverWidget") {
+            NCoverWidget *widget = new NCoverWidget(parent);
+            widget->setObjectName(name);
+            return widget;
+        }
+
+        // For all other widgets, use default QUiLoader behavior
+        return QUiLoader::createWidget(className, parent, name);
+    }
+};
+
+#endif // _N_NO_SKINS_
+
+#endif // N_CUSTOM_UI_LOADER_H
